const getCookie = () =>
  new Promise<TampermonkeyBeta.Cookie[]>((resolve, reject) => {
    GM_cookie('list', {}, (cookie, error) => {
      if (error) {
        reject(error);
      } else {
        resolve(cookie);
      }
    });
  });

const setCookie = (cookieObj: TampermonkeyBeta.Cookie) =>
  new Promise<TampermonkeyBeta.Cookie[]>((resolve, reject) => {
    GM_cookie('set', cookieObj, (cookie, error) => {
      if (error) {
        reject(error);
      } else {
        resolve(cookie);
      }
    });
  });

const deleteCookie = async () => {
  const currentCookie = await getCookie();
  if (currentCookie.length === 0) {
    return [];
  }
  return new Promise<TampermonkeyBeta.Cookie[]>((resolve, reject) => {
    currentCookie.forEach((cookieRecord) => {
      GM_cookie('delete', { name: cookieRecord.name }, (cookie, error) => {
        if (error) {
          reject(error);
        } else {
          resolve(cookie);
        }
      });
    });
  });
};

export { getCookie, setCookie, deleteCookie };
